; Stromanzeige-Platine SAP9000, SAP90V2.s Haupt-Routine
; V2 = erweitert: zustzlich 50Hz-Messung

.equ __33FJ16MC102, 1 
.include "p33FJ16MC102.inc"
.include "ram.inc"

; 8MHZ-Quartz, PLL=4, /2 = 16MHz
config 	__CONFIG2, FNOSC_PRIPLL & POSCMOD_MS & OSCIOFNC_ON	; Quartz + PLL

; Wachhund = aus, PICKIT an PGD3
config	__CONFIG1,ICS_PGD3 & FWDTEN_OFF

.global	__reset
.global __INT1Interrupt
.global __T1Interrupt

; RAM
.section	MAINRAM, bss, address(0x850)

.text	

__reset:
;stack setzen
	mov 	#stackanfang,w15
	mov 	#stackanfang+100,W0
	mov 	W0,_SPLIM
; RAM lschen
 	mov		#0x850,w0
 	repeat	#(ramende-ramanfang)
 	clr		[w0++]

; Peripherie Module abschalten
	mov		#0b1100011111111110,w0	; Timer 1,2,3,ADW = on
	mov		w0,PMD1
	mov		#0xffff,w0
	mov		w0,PMD2
	mov		w0,PMD3
	mov		w0,PMD4

; Port A: b1,b0 = Analog Eingnge
	MOV 	#0x0003, W0
	MOV 	W0, TRISA
	
; Analogeingng
	mov		#0b1111000,w0	; 0 = Analogeingang
	MOV		W0,AD1PCFGL
	
; Port B: Eingnge b15-b6,b4-b1 = Ausgang, b5,b0 =Eingang (INT1,AN2)
	mov		#0b0100001,W0
	mov		w0,TRISB
	nop
	bclr	LATB,#6
	
; Timer 1 Interrupt alle 100us
	clr		T1CON
	clr		TMR1
	mov		#0b000100000,w0 		; int Clk 62.5ns * 64 = 4us
	mov		w0,T1CON
	mov		#25,w0			; ?? 4 x 25 = ca. 100us
	mov		w0,PR1
	BCLR 	IFS0,#T1IF 
	bset 	IEC0,#T1IE
	bset	T1CON,#TON
	
; Timer2 und Timer3: 32-bit Zhler
	clr		T2CON			; 32bit,CPU-CLk 1:1
	bset	T2CON,#T32
	clr		T3CON
	
; Interrupt-Eingang INT1
	bset	INTCON2,#INT1EP		; neg Flanke
	bclr	IFS1,#INT1IF
	bset	IEC1,#INT1IE		; INT0 erlauben
	
; Interrupt-Prioritt Int1 = 7 (hchste), Timer1 = 4
	mov		#0b0000000000000111,w0
	mov		w0,IPC5
	
; Interrupt-Eingang 1 auf PORTB.5 legen
	mov		#0x0500,w0
	mov		w0,RPINR0
	
; PSV aktivieren
	bset	CORCON,#PSV
	mov		#psvpage(Zeile1),w0
	mov		w0,PSVPAG
	
; LCD und Analog
	call	LCDinit
	call	ADWinit
;	clr		TMR1

; Hauptschleife	
hp:
	call	Betrieb
	nop
	nop
	call	ADWcon
	nop
	nop
	call	LCDout
	nop
	nop
	call	Monitor
	nop
	nop
	call	Timer
 	nop
	nop
	call	RSout
	nop
	goto	hp



;---------------------------------------------------
; Pin INT0 = Interrupt fr die 50Hz-Messung, alle 10ms
; reservierte Register: W7,  w13, w14

__INT1Interrupt:
	bclr	IFS1,#INT1IF

; Messung beginnt?
	cp0		w7
	bra		nz,int1a
; Messung Anfang
	mov		#100,w7
	clr		TMR3HLD
	clr		TMR3
	nop
	clr		TMR2
	nop
	bset	T2CON,#TON
	retfie
; Messung fertig?
int1a:
	dec		w7,w7
	bra		z,int1b
; nicht fertig
	retfie
; Messung Ende
int1b:
	bclr	T2CON,#TON
	mov		TMR3,w14	
	mov		TMR2,w13
	retfie	

; Interrupt wird alle 100us aktiv

__T1Interrupt:
	BCLR 	IFS0,#T1IF ; Reset Timer1 interrupt flag
 	inc		takt100

; fr RS232, das zu sendete bit wird in W12-b0 bergeben
; Steuerbit in W11-b0

	btss	w11,#0
	retfie
	bclr	w11,#0
	btst.c	w12,#0
	bra		c,t1int2
	bset	LATB,#7
	retfie
t1int2:
	bclr	LATB,#7
	retfie

__DefaultInterrupt:
	nop
	nop
	retfie
		